"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactJss = _interopRequireDefault(require("react-jss"));

var _reactEventListener = _interopRequireDefault(require("react-event-listener"));

var _styles = _interopRequireDefault(require("./styles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

/**
 * A component to render a parallax effect.
 *
 * @class
 * @extends React.PureComponent
 */
var Parallax =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(Parallax, _React$PureComponent);

  function Parallax() {
    var _ref;

    var _temp, _this;

    _classCallCheck(this, Parallax);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _possibleConstructorReturn(_this, (_temp = _this = _possibleConstructorReturn(this, (_ref = Parallax.__proto__ || Object.getPrototypeOf(Parallax)).call.apply(_ref, [this].concat(args))), Object.defineProperty(_assertThisInitialized(_this), "state", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: {
        transform: 0
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "container", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _react.default.createRef()
    }), Object.defineProperty(_assertThisInitialized(_this), "image", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: _react.default.createRef()
    }), Object.defineProperty(_assertThisInitialized(_this), "imageIsLoaded", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: false
    }), Object.defineProperty(_assertThisInitialized(_this), "overflowImageHeight", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    }), Object.defineProperty(_assertThisInitialized(_this), "containerMiddle", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    }), Object.defineProperty(_assertThisInitialized(_this), "pixelsToScroll", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    }), Object.defineProperty(_assertThisInitialized(_this), "handleScroll", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: {
        handler: function handler() {
          return _this.positionImage();
        },
        options: {
          passive: true,
          capture: false
        }
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "handleResize", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value() {
        _this.computeValues();

        _this.positionImage();
      }
    }), Object.defineProperty(_assertThisInitialized(_this), "handleImageLoad", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value() {
        _this.imageIsLoaded = true;

        _this.computeValues();

        _this.positionImage();
      }
    }), _temp));
  }

  _createClass(Parallax, [{
    key: "computeValues",

    /**
     * Compute some static values which don't change when the user scrolls.
     *
     * @private
     */
    value: function computeValues() {
      if (!this.imageIsLoaded) {
        return;
      }

      var imageHeight = this.image.current ? this.image.current.getBoundingClientRect().height : 0;
      var containerHeight = this.container.current ? this.container.current.getBoundingClientRect().height : 0;
      this.overflowImageHeight = imageHeight - containerHeight;
      this.containerMiddle = containerHeight / 2;
      this.pixelsToScroll = window.innerHeight - containerHeight;
    }
    /**
     * Get the current transform for the position.
     *
     * @param {Object} containerRect - The rectangle of the container for
     * calculating the position.
     * @returns {String} - Returns the transform for the current position.
     */

  }, {
    key: "computeTransform",
    value: function computeTransform(containerRect) {
      if (containerRect.top < 0) {
        return 0;
      } else if (containerRect.bottom > window.innerHeight) {
        return -this.overflowImageHeight;
      }

      return containerRect.top / this.pixelsToScroll * -this.overflowImageHeight;
    }
    /**
     * Reposition the image based on the current scroll position.
     *
     * @private
     */

  }, {
    key: "positionImage",
    value: function positionImage() {
      var _this2 = this;

      if (!this.imageIsLoaded || !this.container.current) {
        return;
      }

      var containerRect = this.container.current.getBoundingClientRect();
      this.setState(function (state) {
        var transform = _this2.computeTransform(containerRect);

        return transform === state.transform ? null : {
          transform: transform
        };
      });
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_reactEventListener.default, {
        target: "window",
        onResize: this.handleResize,
        onScroll: this.handleScroll
      }, _react.default.createElement("div", {
        role: "presentation",
        className: "".concat(this.props.classes.container, " ").concat(this.props.className),
        ref: this.container
      }, _react.default.createElement("img", {
        width: "100%",
        src: this.props.img,
        className: this.props.classes.image,
        alt: "parallax",
        ref: this.image,
        style: {
          transform: "translate3D(0, ".concat(this.state.transform, "px, 0)")
        },
        onLoad: this.handleImageLoad
      }), _react.default.createElement("div", {
        className: this.props.classes.content
      }, this.props.children)));
    }
  }]);

  return Parallax;
}(_react.default.PureComponent);

Object.defineProperty(Parallax, "propTypes", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    classes: _propTypes.default.shape({
      container: _propTypes.default.string.isRequired,
      image: _propTypes.default.string.isRequired,
      content: _propTypes.default.string.isRequired
    }).isRequired,
    img: _propTypes.default.string.isRequired,
    children: _propTypes.default.node,
    className: _propTypes.default.string
  }
});
Object.defineProperty(Parallax, "defaultProps", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    children: '',
    className: ''
  }
});

var _default = (0, _reactJss.default)(_styles.default, {
  inject: ['classes']
})(Parallax);

exports.default = _default;