"use strict";

var _react = _interopRequireDefault(require("react"));

var _ava = _interopRequireDefault(require("ava"));

var _enzyme = require("enzyme");

var _ = _interopRequireDefault(require("."));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _ava.default)('should render a Jss HoC and the actual Parallax component', function (t) {
  var wrapper = (0, _enzyme.mount)(_react.default.createElement(_.default, {
    img: "img"
  }, "Children"));
  t.deepEqual(wrapper.find('Jss(Parallax)').length, 1);
  t.deepEqual(wrapper.find('Parallax').length, 1);
});
(0, _ava.default)('should render correct dom elements', function (t) {
  var wrapper = (0, _enzyme.mount)(_react.default.createElement(_.default, {
    img: "img"
  }, "Children"));
  t.deepEqual(wrapper.find('div.parallax').length, 1);
  t.deepEqual(wrapper.find('img.parallax--image').length, 1);
  t.deepEqual(wrapper.find('div.parallax--content').length, 1);
  t.deepEqual(wrapper.find('div.parallax--content').text(), 'Children');
});
(0, _ava.default)('should not compute the values and position the image when it\'s not loaded yet', function (t) {
  var wrapper = (0, _enzyme.mount)(_react.default.createElement(_.default, {
    img: "img"
  }, "Children"));
  wrapper.find('EventListener').prop('onResize')();
  t.pass();
});
(0, _ava.default)('should compute the values and the position when the image is loaded', function (t) {
  var wrapper = (0, _enzyme.mount)(_react.default.createElement(_.default, {
    img: "img"
  }, "Children"));
  wrapper.find('img').simulate('load');
  t.pass();
});